Package org.optaplanner.core.api.score.buildin.bendable

## Interface BendableScoreHolder

- All Superinterfaces:
    `ScoreHolder<BendableScore>`
  All Known Implementing Classes:
    `BendableScoreHolderImpl`

      public interface BendableScoreHolder
      extends ScoreHolder<BendableScore>

  See Also:
    `BendableScore`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int hardLevel, int weight)` |
    `void` | `addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int[] hardWeights, int[] softWeights)` |
    `void` | `addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, int softLevel, int weight)` |
    `int` | `getHardLevelsSize()` |
    `int` | `getSoftLevelsSize()` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` |
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, int[] hardWeightsMultiplier, int[] softWeightsMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, int[] hardWeightsMultiplier, int[] softWeightsMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level.

    - ### Methods inherited from interface org.optaplanner.core.api.score.holder.ScoreHolder

      `penalize, reward`

- - ### Method Detail

    - #### getHardLevelsSize

          int getHardLevelsSize()

    - #### getSoftLevelsSize

          int getSoftLevelsSize()

    - #### penalize

          void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                        int weightMultiplier)

      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### penalize

          void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                        int[] hardWeightsMultiplier,
                        int[] softWeightsMultiplier)

      Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level. Slower than `penalize(RuleContext, int)`.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightsMultiplier` - elements at least 0
        `softWeightsMultiplier` - elements at least 0

    - #### reward

          void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                      int weightMultiplier)

      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                      int[] hardWeightsMultiplier,
                      int[] softWeightsMultiplier)

      Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level. Slower than `reward(RuleContext, int)`.
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightsMultiplier` - elements at least 0
        `softWeightsMultiplier` - elements at least 0

    - #### impactScore

          void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                           int weightMultiplier)

    - #### addHardConstraintMatch

          void addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                      int hardLevel,
                                      int weight)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardLevel` - `0 <= hardLevel <` `getHardLevelsSize()`. The `scoreLevel` is `hardLevel` for hard levels and `softLevel + hardLevelSize` for soft levels.
        `weight` - higher is better, negative for a penalty, positive for a reward

    - #### addSoftConstraintMatch

          void addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                      int softLevel,
                                      int weight)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `softLevel` - `0 <= softLevel <` `getSoftLevelsSize()`. The `scoreLevel` is `hardLevel` for hard levels and `softLevel + hardLevelSize` for soft levels.
        `weight` - higher is better, negative for a penalty, positive for a reward

    - #### addMultiConstraintMatch

          void addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                       int[] hardWeights,
                                       int[] softWeights)

      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeights` - never null, array of length `getHardLevelsSize()`
        `softWeights` - never null, array of length `getSoftLevelsSize()`